<?php
/**
 * Platnosci CashBill S.A.
 *
 * @package		Cashbill S.A.
 * @author		G.M.
 * @license		http://www.gnu.org/licenses/gpl-3.0.txt
 * @link		http://www.cashbill.pl
 * @filesource
 */

class ControllerPaymentCashBill extends Controller 
{
	
	public function index()
	{

		$data['button_confirm'] = $this->language->get('button_confirm');
		
		$this->load->model('checkout/order');


		$sa_order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		$sa_order_id = $this->session->data['order_id'];
		
		$amount = $this->currency->format($sa_order_info['total'], $sa_order_info['currency_code'], $sa_order_info['currency_value'], false);
		$data['cb_amount'] = $amount;

		$cb_pp_user = $this->config->get('cashbill_pp_user');
		$cb_pp_key = $this->config->get('cashbill_pp_key');

		$data['cb_pp_user'] = $cb_pp_user;
		$data['cb_email'] = $sa_order_info['email'];

		$this->language->load('payment/cashbill');
		$desc = $this->language->get('payment_description').'['.$sa_order_id.']';
		$data['cb_desc'] = $desc;
		$userdata = $sa_order_id;
		$data['cb_userdata'] = $userdata;
        
		$cb_clientData = array(
		    'ref'       => 'OpenCart',
			'forname'	=> $sa_order_info['payment_firstname'],
			'surname'	=> $sa_order_info['payment_lastname'],
			'email'		=> $sa_order_info['email'],
			'tel'		=> $sa_order_info['telephone'],
			'street'	=> $sa_order_info['payment_address_1'],
			'street_n1'	=> $sa_order_info['payment_address_2'],
			'street_n2'	=> '',
			'city'		=> $sa_order_info['payment_city'],
			'postcode'	=> $sa_order_info['payment_postcode'],
			'country'	=> $sa_order_info['payment_country']
		);
		
		$data['cb_currency'] = $this->currency->getCode();
		$data['cb_clientData'] = $cb_clientData;
		

		$sign = md5 ($cb_pp_user.$amount.$desc.$userdata.implode("", $cb_clientData).$cb_pp_key );
		
		$data['cb_sign'] = $sign;
		$message = 'Rozpoczęcie płatności o numerze id : '.$sa_order_id.' w serwisie CashBill.pl';
		$this->model_checkout_order->addOrderHistory($sa_order_id, $this->config->get('cashbill_start_order_status_id'), $message, false);
		
		
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/cashbill.tpl')) {
		    return $this->load->view($this->config->get('config_template') . '/template/payment/cashbill.tpl', $data);
		} else {
		    return $this->load->view('default/template/payment/cashbill.tpl', $data);
		}
	}
	

	

	public function callback()
	{
	
	    if (isset($this->request->get['userdata']) && md5($_GET['service'].$_GET['orderid'].$_GET['amount'].$_GET['userdata'].$_GET['status'].$this->config->get('cashbill_pp_key')) == $_GET['sign']) 
	    {
	        $order_id = $this->request->get['userdata'];
	         
	        $this->load->model('checkout/order');
	        
	        $order_info = $this->model_checkout_order->getOrder($order_id);
	        if(strtoupper($_GET['status']) == 'OK')
	        {
	            
	            if($order_info['order_status_id'] != $this->config->get('cashbill_paid_order_status_id'))
	            {
	            $message = 'Płatność w kwocie '.$_GET['amount'].' PLN została przyjęta przez CashBill.pl';
	            $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('cashbill_paid_order_status_id'), $message, false);
	            }
	            $this->response->redirect($this->url->link('checkout/success'));
	            
	        }else
	        {
	            if($order_info['order_status_id'] != $this->config->get('cashbill_cancel_order_status_id'))
	            {
	            $message = 'Płatność nie została przyjęta przez CashBill';
	            $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('cashbill_cancel_order_status_id'), $message, false);
	            }
	            $this->response->redirect($this->url->link('checkout/failure'));
	        }

	        return;
	    }
	     
	   if (isset($this->request->post['userdata']) && md5($_POST['service'].$_POST['orderid'].$_POST['amount'].$_POST['userdata'].$_POST['status'].$this->config->get('cashbill_pp_key')) == $_POST['sign']) 
	    {
	        $order_id = $this->request->post['userdata'];
	         
	        $this->load->model('checkout/order');
	
	        $order_info = $this->model_checkout_order->getOrder($order_id);
	         
	        if(strtoupper($_POST['status']) == 'OK')
	        {
	            if($order_info['order_status_id'] != $this->config->get('cashbill_paid_order_status_id'))
	            {
	            $message = 'Płatność w kwocie '.$_POST['amount'].' PLN została przyjęta przez CashBill.pl';
	             
	            $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('cashbill_paid_order_status_id'), $message, false);
	            }
	        }else
	        {
	            if($order_info['order_status_id'] != $this->config->get('cashbill_cancel_order_status_id'))
	            {
	            $message = 'Płatność nie została przyjęta przez CashBill';
	             
	            $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('cashbill_cancel_order_status_id'), $message, false);
	            }
	            }
	         
	         
	         echo 'OK';
	         
	         exit();
	    }
	    
	    
	    
	     $this->response->redirect($this->url->link('checkout/failure'));
	}
		
	
	
	
	
	
	
	
	
	

		
}
?>
